*$ CREATE MGDRAW.FOR
*COPY MGDRAW
*                                                                      *
*=== mgdraw ===========================================================*
*                                                                      *
      SUBROUTINE MGDRAW ( ICODE, MREG )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1990-2006      by        Alfredo Ferrari           *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     MaGnetic field trajectory DRAWing: actually this entry manages   *
*                                        all trajectory dumping for    *
*                                        drawing                       *
*                                                                      *
*     Created on   01 march 1990   by        Alfredo Ferrari           *
*                                              INFN - Milan            *
*     Last change  05-may-06       by        Alfredo Ferrari           *
*                                              INFN - Milan            *
*                                                                      *
*----------------------------------------------------------------------*
*
      INCLUDE '(CASLIM)'
      INCLUDE '(COMPUT)'
      INCLUDE '(SOURCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(GENSTK)'
      INCLUDE '(MGDDCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(QUEMGD)'
      INCLUDE '(SUMCOU)'
      INCLUDE '(TRACKR)'
*
      PARAMETER (NNTUPLE=7)
C     REAL*4 XTUP(nntuple)
C     PARAMETER (NNTUPLE=3)
      REAL*4 ETUP(nntuple)
C      REAL*8 ZCUT,RCUT
C      DATA ZCUT/0.998629535/
C      DATA RCUT/0.052335956/
C      REAL*8 TMP
      INTEGER LSTPR
      DATA LSTPR /0/
      integer i
      integer fpid(12)          ! Fluka Partcile ID
      integer gpid(12)          ! Geant Particle ID
      data fpid / 1,  8, 13, 14, 15, 16, 10, 11,  7,   3,  4,  2/
C                 P   N   PI+ PI- K+  K-  MU+ MU- GAM E-  E+  AP
      data gpid /14, 13,  8,  9, 11, 12,  5,  6,  1,   3,  2, 15/
      REAL*8 PST(3),DRC(3)
 2007 FORMAT('transfer ',I3,3F8.3,4F8.4)
 2008 FORMAT('transfer ',I8,' events')
*
      DIMENSION DTQUEN ( MXTRCK, MAXQMG )
*
      CHARACTER*20 FILNAM
      LOGICAL LFCOPE
      SAVE LFCOPE
      DATA LFCOPE / .FALSE. /
*
*----------------------------------------------------------------------*
*                                                                      *
*     Icode = 1: call from Kaskad                                      *
*     Icode = 2: call from Emfsco                                      *
*     Icode = 3: call from Kasneu                                      *
*     Icode = 4: call from Kashea                                      *
*     Icode = 5: call from Kasoph                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF
      WRITE (IODRAW) NTRACK, MTRACK, JTRACK, SNGL (ETRACK),
     &               SNGL (WTRACK)
      WRITE (IODRAW) ( SNGL (XTRACK (I)), SNGL (YTRACK (I)),
     &                 SNGL (ZTRACK (I)), I = 0, NTRACK ),
     &               ( SNGL (DTRACK (I)), I = 1, MTRACK ),
     &                 SNGL (CTRACK)
*  +-------------------------------------------------------------------*
*  |  Quenching is activated
      IF ( LQEMGD ) THEN
         IF ( MTRACK .GT. 0 ) THEN
            RULLL  = ZERZER
            CALL QUENMG ( ICODE, MREG, RULLL, DTQUEN )
            WRITE (IODRAW) ( ( SNGL (DTQUEN (I,JBK)), I = 1, MTRACK ),
     &                         JBK = 1, NQEMGD )
         END IF
      END IF
*  |  End of quenching
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     Boundary-(X)crossing DRAWing:                                    *
*                                                                      *
*     Icode = 1x: call from Kaskad                                     *
*             19: boundary crossing                                    *
*     Icode = 2x: call from Emfsco                                     *
*             29: boundary crossing                                    *
*     Icode = 3x: call from Kasneu                                     *
*             39: boundary crossing                                    *
*     Icode = 4x: call from Kashea                                     *
*             49: boundary crossing                                    *
*     Icode = 5x: call from Kasoph                                     *
*             59: boundary crossing                                    *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY BXDRAW ( ICODE, MREG, NEWREG, XSCO, YSCO, ZSCO )
C     IF (MREG.EQ.4.AND.NEWREG.EQ.3) THEN
C        WRITE(*,*) 'BXDRW',MREG,NEWREG,JTRACK,ETRACK
C        WRITE(49,*) 'BXDRW',MREG,NEWREG,JTRACK,ETRACK
C        IF(JTRACK.EQ.13) THEN
C           ETUP(1)=PTRACK
C        ENDIF
C        IF(JTRACK.EQ.15) THEN
C           ETUP(2)=PTRACK
C        ENDIF
C     ENDIF 
      IF (NCASE.NE.LSTPR) THEN 
         IF (LSTPR.NE.0) WRITE(49,*) 'transfer finished'
         WRITE(49,2008) ncase
         LSTPR=NCASE
      ENDIF
      IF (MREG.EQ.6.AND.NEWREG.EQ.2) THEN
         WRITE(*,*) 'BXDRAW ',icode,mreg,newreg,jtrack
     $        ,etrack,am(jtrack) 
C         TMP = ETRACK-AM(JTRACK)
         IF (PTRACK .GE. 0.1) THEN
            DO 200, I=1,12
               IF (JTRACK.EQ.FPID(I).AND.JTRACK.NE.7) THEN ! Skip photons
                  ETUP(1)=GPID(I)
                  PST(1)=XSCO
                  PST(2)=YSCO
                  PST(3)=ZSCO
                  ETUP(2)=XSCO
                  ETUP(3)=YSCO
                  ETUP(4)=ZSCO
                  DRC(1)=CXTRCK
                  DRC(2)=CYTRCK
                  DRC(3)=CZTRCK
                  ETUP(5)=PTRACK*CXTRCK
                  ETUP(6)=PTRACK*CYTRCK
                  ETUP(7)=PTRACK*CZTRCK
                  WRITE(49,2007)GPID(I),(PST(I),I=1,3),(DRC(I),I=1,3),
     +                 PTRACK
                  CALL HFN(100,ETUP)
                  RETURN
               ENDIF
 200        CONTINUE
         ENDIF
      ENDIF
*
C      WRITE(*,*) 'BXDRAW ',icode,mreg,newreg,jtrack
C     $     ,etrack,am(jtrack) 
C      IF(MREG.EQ.4.AND.NEWREG.EQ.3) THEN          ! Select the desired boundary
C         IF( JTRACK.EQ.13) THEN                   ! Select pion+
C               XTUP(1) = ETRACK-AM(JTRACK)        ! Kinetic energy
C               XTUP(2) = CXTRCK                   ! Direction cosines 
C               XTUP(3) = CYTRCK
C               XTUP(4) = CZTRCK
C               CALL HFN(100,XTUP)
C         ENDIF
C      ENDIF 
      RETURN
*
*      END IF
*
*======================================================================*
*                                                                      *
*     Event End DRAWing:                                               *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY EEDRAW ( ICODE )
      RETURN
*
*======================================================================*
*                                                                      *
*     ENergy deposition DRAWing:                                       *
*                                                                      *
*     Icode = 1x: call from Kaskad                                     *
*             10: elastic interaction recoil                           *
*             11: inelastic interaction recoil                         *
*             12: stopping particle                                    *
*             13: pseudo-neutron deposition                            *
*             14: escape                                               *
*             15: time kill                                            *
*     Icode = 2x: call from Emfsco                                     *
*             20: local energy deposition (i.e. photoelectric)         *
*             21: below threshold, iarg=1                              *
*             22: below threshold, iarg=2                              *
*             23: escape                                               *
*             24: time kill                                            *
*     Icode = 3x: call from Kasneu                                     *
*             30: target recoil                                        *
*             31: below threshold                                      *
*             32: escape                                               *
*             33: time kill                                            *
*     Icode = 4x: call from Kashea                                     *
*             40: escape                                               *
*             41: time kill                                            *
*             42: delta ray stack overflow                             *
*     Icode = 5x: call from Kasoph                                     *
*             50: optical photon absorption                            *
*             51: escape                                               *
*             52: time kill                                            *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY ENDRAW ( ICODE, MREG, RULL, XSCO, YSCO, ZSCO )
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF
      WRITE (IODRAW)  0, ICODE, JTRACK, SNGL (ETRACK), SNGL (WTRACK)
      WRITE (IODRAW)  SNGL (XSCO), SNGL (YSCO), SNGL (ZSCO), SNGL (RULL)
*  +-------------------------------------------------------------------*
*  |  Quenching is activated : calculate quenching factor
*  |  and store quenched energy in DTQUEN(1, jbk)
      IF ( LQEMGD ) THEN
         RULLL = RULL
         CALL QUENMG ( ICODE, MREG, RULLL, DTQUEN )
         WRITE (IODRAW) ( SNGL (DTQUEN(1, JBK)), JBK = 1, NQEMGD )
      END IF
*  |  end quenching
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     SOurce particle DRAWing:                                         *
*                                                                      *
*======================================================================*
*
      ENTRY SODRAW
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF
      WRITE (IODRAW) -NCASE, NPFLKA, NSTMAX, SNGL (TKESUM),
     &                SNGL (WEIPRI)
*  +-------------------------------------------------------------------*
*  |  (Radioactive) isotope: it works only for 1 source particle on
*  |  the stack for the time being
      IF ( ILOFLK (NPFLKA) .GE. 100000 .AND. LRADDC (NPFLKA) ) THEN
         IARES  = MOD ( ILOFLK (NPFLKA), 100000  )  / 100
         IZRES  = MOD ( ILOFLK (NPFLKA), 10000000 ) / 100000
         IISRES = ILOFLK (NPFLKA) / 10000000
         IONID  = ILOFLK (NPFLKA)
         WRITE (IODRAW) ( IONID,SNGL(-TKEFLK(I)),
     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
*  |
*  +-------------------------------------------------------------------*
*  |  Patch for heavy ions: it works only for 1 source particle on
*  |  the stack for the time being
      ELSE IF ( ABS (ILOFLK (NPFLKA)) .GE. 10000 ) THEN
         IONID = ILOFLK (NPFLKA)
         CALL DCDION ( IONID )
         WRITE (IODRAW) ( IONID,SNGL(TKEFLK(I)+AMNHEA(-IONID)),
     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
*  |
*  +-------------------------------------------------------------------*
*  |  Patch for heavy ions: ???
      ELSE IF ( ILOFLK (NPFLKA) .LT. -6 ) THEN
         WRITE (IODRAW) ( IONID,SNGL(TKEFLK(I)+AMNHEA(-ILOFLK(NPFLKA))),
     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
*  |
*  +-------------------------------------------------------------------*
*  |
      ELSE
         WRITE (IODRAW) ( ILOFLK(I), SNGL (TKEFLK(I)+AM(ILOFLK(I))),
     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
      END IF
*  |
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     USer dependent DRAWing:                                          *
*                                                                      *
*     Icode = 10x: call from Kaskad                                    *
*             100: elastic   interaction secondaries                   *
*             101: inelastic interaction secondaries                   *
*             102: particle decay  secondaries                         *
*             103: delta ray  generation secondaries                   *
*             104: pair production secondaries                         *
*             105: bremsstrahlung  secondaries                         *
*             110: decay products                                      *
*     Icode = 20x: call from Emfsco                                    *
*             208: bremsstrahlung secondaries                          *
*             210: Moller secondaries                                  *
*             212: Bhabha secondaries                                  *
*             214: in-flight annihilation secondaries                  *
*             215: annihilation at rest   secondaries                  *
*             217: pair production        secondaries                  *
*             219: Compton scattering     secondaries                  *
*             221: photoelectric          secondaries                  *
*             225: Rayleigh scattering    secondaries                  *
*     Icode = 30x: call from Kasneu                                    *
*             300: interaction secondaries                             *
*     Icode = 40x: call from Kashea                                    *
*             400: delta ray  generation secondaries                   *
*  For all interactions secondaries are put on GENSTK common (kp=1,np) *
*  but for KASHEA delta ray generation where only the secondary elec-  *
*  tron is present and stacked on FLKSTK common for kp=npflka          *
*                                                                      *
*======================================================================*
*
      ENTRY USDRAW ( ICODE, MREG, XSCO, YSCO, ZSCO )


C      WRITE(*,*) 'USDRAW',icode,jtrack,mreg,etrack,am(jtrack) 
C     IF(JTRACK.EQ.13.AND.NP.EQ.2.AND.ICODE.EQ.102) THEN
C           ETUP(1)=ETRACK-AM(JTRACK)
C        TMP=CXTRCK*CXTRCK+CYTRCK*CYTRCK
C        IF(CZTRCK.GE.ZCUT.AND.TMP.LE.RCUT*RCUT) THEN
C           WRITE(*,*) 'USDRAW',icode,jtrack,mreg,etrack,np,
C    $           kpart(1),kpart(2) 
C           IF(KPART(1).EQ.10.AND.KPART(2).EQ.27) THEN
C              ETUP(1)=ETRACK-AM(JTRACK)
C              ETUP(2)=CXTRCK
C              ETUP(3)=CYTRCK
C              ETUP(4)=CZTRCK
C              ETUP(5)=TKI(1)
C              ETUP(6)=TKI(2)
C           ENDIF
C           CALL HFN(100,ETUP)
C        ENDIF
C     ENDIF
       IF ( .NOT. LFCOPE ) THEN
          LFCOPE = .TRUE.
          IF ( KOMPUT .EQ. 2 ) THEN
             FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
          ELSE
             FILNAM = CFDRAW
          END IF
          OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM = 
     &         'UNFORMATTED' )
       END IF
* No output by default:
      RETURN
*=== End of subrutine Mgdraw ==========================================*
      END

